       PROGRAM CONEXPL
C           Last change:  SHI   5 Aug 2002    5:21 pm
C
C
C
C:::PROGRAMA PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURAS
C:::DE FORMA EXPLCITA, INCLUYENDO LOS PROCESOS DE TRANSPORTE DE CALOR POR 
C:::CONDUCCIN Y CONVECCIN.
C:::AUTOR: SALVADOR HERNANDEZ IBAEZ

      IMPLICIT DOUBLE PRECISION (A-H,M,L,O-Z)
      DIMENSION R12(101,110),Z12(101,110),VR(100,100),
     & POT(100,100),POTM(100,100),LC(100,100),DELTAR(100,100),
     & GRADTM(100,100),GRADT(100,100),RO(100,100),ROm(100,100)
      DIMENSION ESPN(100,100),ESPN12(101,110),AR(100,100),AZ(100,100),
     & DIFR12(101,110),T(100,100),TM(100,100),P(100,100),
     & PM(100,100),R(100,100),Z(100,100),DELTAR12(100,100),
     & DEL(100,100),ho(100,100),hom(100,100),hot(100,100),LOOR(100,100),
     & DENSO(100,100),DENSOM(100,100),qoaste(100,100),QoAST(100,100),
     & CP(100,100),CPM(100,100),MUO(100,100),MUOMAT(100,100),
     & LOOZ(100,100),LAMBDAOO(100,100),JI(100,100),CCONVO(100,100),
     & EPSILO(100,100),AA(100,100),BB(100,100),CC(100,100),DD(100,100),
     & EE(100,100),A(100,100),B(100,100),C(100,100),D(100,100),
     & E(100,100),F(100,100),G(100,100),H(100,100),H1(100,100),
     & H2(100,100),X(100,100),PSNT(100,100),PMSNT(100,100),TE(100,100),
     & hoSNT(100,100),homSNT(100,100),Hm(100,100),H1m(100,100),
     & H2m(100,100),Xm(100,100),DENSOMSNT(100,100),TME(100,100),
     & BO(100,100),DENSOSNT(100,100),GVO(100,100),TSNT(100,100)
      DIMENSION P01R(100,100),P12R(100,100),P01Z(100,100),P12Z(100,100)
      DIMENSION BOT(20),MUOT(20),PRES(1000),COMDEN(100,100),
     & DENT(20),PT(20),DELTAZ(100,100),TODO(100,100)

      COMMON TREF
      OPEN (UNIT=5,FILE='con9.datos',STATUS='OLD')
      OPEN (UNIT=7,FILE='CONEXPL1.RESUL',STATUS='UNKNOWN')
      OPEN (UNIT=8,FILE='CONEXPL1.MALLA',STATUS='UNKNOWN')
      OPEN (UNIT=9,FILE='CONEXPL1.DENS',STATUS='UNKNOWN')

C  -- INFORMACIN INICIAL DE ENTRADA --
      DATA PHI,CR,CD/3.1415926535D0,5.61458331D0,0.001127106753D0/
      CTECALOR=44.856E+14
      CONSPOT=1.0/144.0
      READ(5,*) NX,NY,RW,RE,UNIFORM
C  -- SELECCIN DE DATOS DE ENTRADA, ESPESOR VARIBLE EN LOS NODOS --
      IF (UNIFORM.EQ.0) THEN
         DO 3 J=1,NY
            DO 3 I=1,NX
                 READ(5,*) ESPN(I,J)
   3     CONTINUE

C  -- CALCULA LOS ESPESORES EN LAS FRONTERAS DE LAS CELDAS EN FUNCIN --
C  -- DE LOS ESPESORES DE LOS NODOS --
         DO 66 J=1,NY
           DO 44 I=2,NX
              ESPN12(I,J)=(ESPN(I,J)+ESPN(I-1,J))*0.5
   44       CONTINUE
C  -- EXTRAPOLACIN PARA CALCULAR LOS ESPESORES DE LAS FRONTERAS --
C  -- ES DECIR EN (1,J) Y (NX+1,J) --

          IF (ESPN(2,J).GT.ESPN(1,J))THEN
             ESPN12(1,J)= (ESPN12(2,J)+ESPN(1,J))*0.5
          ELSE
             ESPN12(1,J)=(ESPN(1,J)-ESPN12(2,J))+((ESPN12(2,J)+ESPN(1,J)
     &            )*0.5)
          END IF

               IF (ESPN(2,J).GT.ESPN(1,J))THEN
                   ESPN12(NX+1,J)= (ESPN12(NX,J)+ESPN(NX,J))*0.5
               ELSE
                   ESPN12(NX+1,J)=(ESPN(NX,J)-ESPN12(NX,J))+
     &                  ((ESPN12(NX,J)+ESPN(NX,J))*0.5)
               END IF

   66    CONTINUE

C  -- SE LEE EL ESPESOR TOTAL DEL YACIMIENTO Y SE CALCULA EL DE CADA --
C  -- NODO (ESPESOR CONSTANTE) --
      ELSE
          READ(5,*) ESPE
          ESPESOR=ESPE/NY
      END IF

C  -- INTRODUCCIN DE LOS DATOS PVT vs p
C  -- LEER LA TEMPERATURA DEL EXPERIMENTO (TABLA)
      READ(5,*) TREF,INICIO
      READ(5,*) PERMR,PERMZ,PERMATR,PERMATZ,PORO,POROM
      READ(5,*) CTO,RFCD,SIGMA,PESPO,DENCS,DENSW,CTR
      READ(5,*) DELTAt,IR,IBOUND
      READ(5,*) et,TFRIA,TCALIENTE
      READ(5,*) NPUNTOS
         DO 88 I=1,NPUNTOS
              READ(5,*) PT(I),MUOT(I),BOT(I),DENT(I)
   88  CONTINUE

       TCALIENTE=0.01463*ESPE+TFRIA 
C  -- OTROS DATOS DE ENTRADA
        DO 100 J=1,NY
           DO 100 I=1,NX
             READ(5,*) P(I,J),PM(I,J),PSNT(I,J),PMSNT(I,J),GVO(I,J)
  100    CONTINUE
C      RETURN
C      END

C  -- PERMR.-PERMEABILIDAD DE LA FRACTURA EN DIRECCIN RADIAL
C  -- PERMZ.-PERMEABILIDAD DE LA FRACTURA EN DIRECCIN AXIAL
C  -- PERMATR.-PERMEABILIDAD DE LA MATRIZ EN DIRECCIN RADIAL

C  -- CREACIN DE LA MALLA --
      CALL RADIAL(NX,NY,RW,RE,R,R12,DIFR12,AZ,IR,IBOUND,PHI)
      CALL AXIAL(NX,NY,ESPN,ESPESOR,Z,Z12,UNIFORM,DELTAZ)

C  -- CLCULO DEL VOLUMEN DE ROCA POR CELDA
      IF (UNIFORM.EQ.0) THEN
        DO 1 J=1,NY
           DO 1 I=1,NX
                VR(I,J)= DIFR12(I,J)*ESPN(I,J)
   1    CONTINUE
      ELSE
        DO 2 J=1,NY
           DO 2 I=1,NX
                VR(I,J)= DIFR12(I,J)*ESPESOR
C                WRITE(7,*) VR(I,J)
   2    CONTINUE
      END IF

C  -- CLCULO DEL AREA TRANSVERSAL (POR CELDA) A LA DIRECCIN RADIAL --
      IF (UNIFORM .EQ. 0) THEN
         DO J=1,NY
           AR(1,J)=2*PHI*RW*ESPN(1,J)
           DELTAR(1,J)=R(1,J)
         END DO
         DO  I=2,NX+1
              AR(I,J)=2*PHI*R12(I,J)*ESPN(I,J)
              DELTAR(I,J)=R(I,J)-R(I-1,J)
              DELTAR12(I-1,J)=R12(I,J)-R12(I-1,J)
         END DO
      ELSE
         DO 4 J=1,NY
           AR(1,J)=2*PHI*RW*ESPESOR
           DELTAR(1,J)=R(1,J)
         DO 4 I=2,NX+1
              AR(I,J)=2*PHI*R12(I,J)*ESPESOR
              DELTAR(I,J)=R(I,J)-R(I-1,J)
              DELTAR12(I-1,J)=R12(I,J)-R12(I-1,J)
C              WRITE(7,*)AR(I,J)
   4     CONTINUE
      END IF
C  -- CALCULO O LECTURA DE LAS TEMPERATURAS DE FRACTURA Y MATRIZ
      IF (INICIO .EQ. 1) THEN
        DO J=1,NY
           DO I=1,NX  !CALCULO DE T PARA CUANDO t ES IGUAL A 0
             GRADT(I,J)=0.01463*Z(I,J)+TFRIA !GRAD. EN LA FRACTURA
             GRADTM(I,J)=0.01563*Z(I,J)+TFRIA !GRAD. EN LA MATRIZ
             T(I,J)=0.01463*Z(I,J)+TFRIA !TEMP. EN LA FRACTURA
             TM(I,J)=0.01563*Z(I,J)+TFRIA !TEMP. EN LA MATRIZ
           END DO
        END DO
      ELSE
             GRADT(I,J)=0.01463*Z(I,J)+TFRIA !GRAD. EN LA FRACTURA
             GRADTM(I,J)=0.1463*Z(I,J)+TFRIA !GRAD. EN LA MATRIZ
             READ(5,*) T(I,J),TM(I,J) !LECTURA PARA UN t DIFERENTE DE 0
      END IF

C  -- EL CLCULO DEL AREA TRANSVERSAL (POR CELDA) A LA DIRECCIN AXIAL-
C  -- SE REALIZA EN LA SUBRUTINA RADIAL

C  -- DEFINICI DE LA DISTRIBUCIN DE TEMPERATURAS INICIALES
C  -- Y CLCULO DE LA DENSIDAD EN FUNCIN DE T PARA CADA REGIN
        NXNY=NX*NY
        K=0
       DO I=1,NXNY
         PRES(I)=0.0
       END DO
         DO 11 J=1,NY
          DO 11 I=1,NX
               K=K+1
               PRES(K)=P(I,J)
   11    CONTINUE


      DO 5 J=1,NY
         DO 5 I=1,NX
             CALL INTER(NPUNTOS,PT,DENT,P(I,J),DENSOINT,DDENSO)
             DENSREF=DENSOINT
             DENSO(I,J)=DENSREF*(1-et*(T(I,J)-TREF))
             DENSOM(I,J)=DENSREF*(1-et*(TM(I,J)-TREF))
             qoaste(I,J)=CR*GVO(I,J)*DENSO(I,J)
             QoAST(I,J)=CTECALOR*RFCD
C             WRITE(7,*) P(I,J),DENSREF
C          WRITE(7,*) T(I,J),TM(I,J),DENSO(I,J),DENSOM(I,J)
  5   CONTINUE

C  --  LA DENSIDAD DEL ACEITE EN LA MATRIZ SE LLAMA DENSOM Y LA DE LA
C  --  FRACTURA DENSO.
C  --  qoaste ES EL TRMINO FUENTE O SUMIDERO (MASA) QUE ENTRA EN EL BALANCE

C  --  CONDUCTIVIDAD TRMICA DEL SISTEMA ROCA - ACEITE
      CTSRO=1/((1/CTO)+(1/CTR))
      
C  -- DEFINICIN DE LA DISTRIBUCIN DE PRESIN ORIGINAL EN CADA CELDA
C  -- CALCULO DEL CALOR ESPECFICO EN FUNCIN DE T Y RO, EN CADA REGIN
C  -- CALCULO DE LA ENTALPIA ESPECFICA EN FRACTURA Y MATRIZ
      DO 6 J=1,NY
         DO 6 I=1,NX
C           P(I,J)=PORI
C           PM(I,J)=PORI
           CP(I,J)=(0.388+0.00045*T(I,J))/((DENSO(I,J)/DENSW)**0.5)
           CPM(I,J)=(0.388+0.00045*TM(I,J))/((DENSOM(I,J)/DENSW)**0.5)
C           ho(I,J)=CP(I,J)*T(I,J)+((P(I,J)*0.1852)/DENSO(I,J))
C           hom(I,J)=CPM(I,J)*TM(I,J)+((PM(I,J)*0.1852)/DENSOM(I,J))
         ho(I,J)=25036.86*CP(I,J)*T(I,J)+((P(I,J)*144)/DENSO(I,J))
         hom(I,J)=25036.86*CPM(I,J)*TM(I,J)+((PM(I,J)*144)/DENSOM(I,J))
C              WRITE(*,*) I,J,T(I,J),TM(I,J)
   6  CONTINUE
C      STOP 
C  -- CALCULO DE LA MOVILIDAD LOO EN DIRECCIN RADIAL (FRACTURA)
C        DO 89 I=1,NPUNTOS
C              WRITE(7,*) PT(I),MUOT(I),BOT(I),DENT(I)
C   89  CONTINUE
      DO 7 J=1,NY
         DO 7 I=1,NX
             CALL INTER(NPUNTOS,PT,MUOT,P(I,J),YMUO,DMUO)
                   MUO(I,J)=YMUO
             LOOR(I,J)=(PERMR/MUO(I,J))*DENSO(I,J)
C             WRITE(7,*) P(I,J),MUO(I,J),LOOR(I,J)
   7  CONTINUE
       
C  -- CALCULO DE LA MOVILIDAD LOO EN DIRECCIN AXIAL (FRACTURA)
      DO 8 I=1,NX
         DO 8 J=1,NY
             CALL INTER(NPUNTOS,PT,MUOT,P(I,J),YMUO,DMUO)
             MUO(I,J)=YMUO
             LOOZ(I,J)=(PERMZ/MUO(I,J))*DENSO(I,J)
C             WRITE(7,*) P(I,J),LOOZ(I,J)
   8  CONTINUE
C  -- EN LA MATRIZ NO SE CALCULA LA MOVILIDAD PORQUE ES DOBLE POROSIDAD
C  -- SIN DOBLE PERMEABILIDAD

C  -- SE ESTIMAN LOS POTENCIALES Y LAS FUNCIONES DE TRANSFERENCIA MATRIZ-FRAC.
C  -- CALCULO DEL POTENCIAL PARA AMBAS REGIONES (RADIALMENTE)
       DO 9 J=1,NY
         DO 9 I=1,NX
             POT(I,J) = P(I,J)-(CONSPOT*PESPO*Z(I,J))
             POTM(I,J)= PM(I,J)-(CONSPOT*PESPO*Z(I,J))
C              WRITE(7,*) P(I,J),POT(I,J),C(I,J)
  9   CONTINUE

             
C  -- FUNCIN DE TRANSFERENCIA MATRIZ - FRACTURA PARA EL ACEITE (MASA).
      DO  10 J=1,NY
         DO 10 I=1,NX
                IF (POTM(I,J).GE.POT(I,J)) THEN
                    DEL(I,J)=1
                       CALL INTER(NPUNTOS,PT,MUOT,PM(I,J),YMUOM,DMUOM)
                       MUOMAT(I,J)=YMUOM
C  --  FLUJO DE LA MATRIZ A LA FRACTURA
                    LAMBDAOO(I,J)=SIGMA*(PERMATR*
     &              (DEL(I,J)*(DENSOM(I,J)/MUOMAT(I,J))))
                 hot(I,J)=(DEL(I,J)*hom(I,J))+((1-DEL(I,J))*ho(I,J))
                ELSE
                    DEL(I,J)=0
                       CALL INTER(NPUNOS,PT,MUOT,P(I,J),YMUO,DMUO)
                       MUO(I,J)=YMUO
C  --  FLUJO DE LA FRACTURA A LA MATRIZ
                    LAMBDAOO(I,J)=SIGMA*(PERMR*
     &              (DENSO(I,J)/MUO(I,J)))
                 hot(I,J)=(DEL(I,J)*hom(I,J))+((1-DEL(I,J))*ho(I,J))
                END IF
C              WRITE(7,*) hot(I,J),LAMBDAOO(I,J)
10      CONTINUE


C  -- SE ESTIMAN EL COEF. DE CONVECCIN Y LAS FUNCIONES DE TRANSFERENCIA
C  -- MATRIZ-FRAC., EPSILON EC. III.7.17, hc EC. III.7.5 
C  -- FUNCIN DE TRANSFERENCIA MATRIZ - FRACTURA PARA EL ACEITE (CALOR).
       DO  13 J=1,NY
         DO 13 I=1,NX
            LC(I,J)=VR(I,J)/AR(I,J)
                IF (TM(I,J).GE.T(I,J)) THEN
                    JI(I,J)=1
C  --  FLUJO DE LA MATRIZ A LA FRACTURA
                    CCONVO(I,J)=RFCD/(AR(I,J)*(TM(I,J)-T(I,J)))
                    EPSILO(I,J)=((JI(I,J)*CCONVO(I,J))/LC(I,J))
     &              -((JI(I,J)-1)*(CTSRO/LC(I,J))*
     &              ((1/DELTAR(I,J))+(1/ESPESOR)))
                ELSE
                    JI(I,J)=0
C  --  FLUJO DE LA FRACTURA A LA MATRIZ
                    EPSILO(I,J)=((JI(I,J)*CCONVO(I,J))/LC(I,J))
     &              -((JI(I,J)-1)*(CTSRO/LC(I,J))
     &              *((1/DELTAR(I,J))+(1/ESPESOR)))
                END IF
C              WRITE(7,*) LC(I,J),CCONVO(I,J),EPSILO(I,J)
13     CONTINUE

C  -- CALCULO DE LA PRESIN EN LAS FRONTERAS DE LAS CELDAS(2,NX-1 Y 2,NY-1)
C  -- CON INTERPOLACIN LINEAL
       DO 33 J=2,NY-1
         DO 33 I=2,NX-1
          P01R(I,J)=P(I-1,J)+(((P(I,J)-P(I-1,J))/(R(I,J)-R(I-1,J)))
     &    *(R12(I,J)-R(I-1,J)))
          P12R(I,J)=P(I,J)+(((P(I+1,J)-P(I,J))/(R(I+1,J)-R(I,J)))
     &    *(R12(I+1,J)-R(I,J)))
          P01Z(I,J)=P(I,J-1)+(((P(I,J)-P(I,J-1))/(Z(I,J)-Z(I,J-1)))
     &    *(Z12(I,J)-Z(I,J-1)))
          P12Z(I,J)=P(I,J)+(((P(I,J+1)-P(I,J))/(Z(I,J+1)-Z(I,J)))
     &    *(Z12(I,J+1)-Z(I,J)))
C      WRITE(7,*) P01R(I,J),P12R(I,J),P01Z(I,J)
 33   CONTINUE

C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS
      DO 15 J=2,NY-1
         DO 15 I=2,NX-1
           AA(I,J)=(((LOOR(I,J)*ho(I,J)*AR(I+1,J))/(R(I+1,J)-R(I,J)))
     &            *(P(I+1,J)-P(I,J)))
     &            -(((LOOR(I,J)*ho(I,J)*AR(I,J))/(R(I,J)-R(I-1,J)))
     &            *(P(I,J)-P(I-1,J)))
     &            +(((LOOZ(I,J)*ho(I,J)*AZ(I,J+1))/(Z(I,J+1)-Z(I,J)))
     &            *(P(I,J+1)-P(I,J)-(PESPO*(Z(I,J+1)-Z(I,J))/144)))
     &            -(((LOOZ(I,J)*ho(I,J)*AZ(I,J))/(Z(I,J)-Z(I,J-1)))
     &            *(P(I,J)-P(I,J-1)-(PESPO*(Z(I,J)-Z(I,J-1))/144)))
           A(I,J)=47.227E+06*AA(I,J)

       BB(I,J)=(((CTSRO*AR(I+1,J))/(R(I+1,J)-R(I,J)))*(T(I+1,J)-T(I,J)))
     &      -(((CTSRO*AR(I,J))/(R(I,J)-R(I-1,J)))*(T(I,J)-T(I-1,J)))
     &      +(((CTSRO*AZ(I,J+1))/(Z(I,J+1)-Z(I,J)))*(T(I,J+1)-T(I,J)))
     &      -(((CTSRO*AZ(I,J))/(Z(I,J)-Z(I,J-1)))*(T(I,J)-T(I,J-1)))
           B(I,J)=4.4856E+15*BB(I,J)

      CALL INTER(NPUNTOS,PT,BOT,P(I,J),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(I,J),YMUO,DMUO)
      CALL INTER(NPUNTOS,PT,DENT,P(I,J),DENSOINT,DDENSO)
           MUO(I,J)=YMUO
	     BO(I,J)=YBO
           CC(I,J)=(((PERMR*VR(I,J))/(MUO(I,J)*BO(I,J)))
     & *(((P12R(I,J)-P01R(I,J))/(R12(I+1,J)-R12(I,J)))**2))
     & +(((PERMZ*VR(I,J))/(MUO(I,J)*BO(I,J)))
     & *((((P12Z(I,J)-P01Z(I,J))/(Z12(I,J+1)-Z12(I,J)))**2)
     & -((PESPO/144)*((P12Z(I,J)-P01Z(I,J))/(Z12(I,J+1)-Z12(I,J))))))
           C(I,J)=6800.7E+06*CC(I,J)

           DD(I,J)=LAMBDAOO(I,J)*hot(I,J)*(POTM(I,J)-POT(I,J))
           D(I,J)=47.227E+06*DD(I,J)
           EE(I,J)=EPSILO(I,J)*(TM(I,J)-T(I,J))
           E(I,J)=44.856E+14*EE(I,J)
           F(I,J)=QoAST(I,J)
           G(I,J)=74.6496E+08*qoaste(I,J)*ho(I,J)
           H(I,J)=A(I,J)+B(I,J)-C(I,J)+D(I,J)+E(I,J)-F(I,J)-G(I,J)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

	 CALL INTER(NPUNTOS,PT,DENT,PSNT(I,J),DENSOSNT(I,J),DDENSOSNT)
	 COMDEN(I,J)=PORO*DENSOSNT(I,J)
	 PERTER=(DELTAt*H(I,J))/(74.6496E+08*VR(I,J)*COMDEN(I,J))
	 SDOTER=(1.075E+12*(P(I,J)-PSNT(I,J)))/(74.6496E+08*COMDEN(I,J))
	 TERTER=(PORO*ho(I,J)*DENSO(I,J))/(COMDEN(I,J))
	     hoSNT(I,J)=PERTER-SDOTER+TERTER
             H2(I,J)=hoSNT(I,J)-ho(I,J)

C       WRITE(*,*) I,J
C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(I,J)=-(D(I,J)+E(I,J))

	 CALL INTER(NPUNTOS,PT,DENT,PMSNT(I,J),DENSOMSNT(I,J),DDENSOMSNT)
	 COMDEN(I,J)=POROM*DENSOMSNT(I,J)
	 PERTER=(DELTAt*Hm(I,J))/(74.6496E+08*VR(I,J)*COMDEN(I,J))
	 SDOTER=(1.075E+12*(PM(I,J)-PMSNT(I,J)))/(74.6496E+08*COMDEN(I,J))
	 TERTER=(POROM*hom(I,J)*DENSOM(I,J))/(COMDEN(I,J))
	     homSNT(I,J)=PERTER-SDOTER+TERTER
             H2m(I,J)=homSNT(I,J)-hom(I,J)
C            WRITE(9,*) PSNT(I,J)
C           WRITE(7,*) A(I,J)
C           WRITE(7,*) B(I,J),C(I,J),D(I,J)
C           WRITE(7,*) E(I,J),F(I,J),G(I,J)
C           WRITE(8,*) hoSNT(I,J),ho(I,J),H2(I,J)
   15 CONTINUE

      DO  J=2,NY-1
	  DO I=2,NX-1
C       WRITE(*,*) I,J,H2(I,J)
C  -- CALCULO DE LA TEMPERATURA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

      CALL MNEWTON(I,J,T(I,J),P(I,J),DENSO(I,J),DENSOSNT(I,J),hoSNT(I,J)
     &     ,PSNT(I,J),et,H2(I,J),RO(I,J),TE(I,J))

C  -- CALCULO DE LA TEMPERATURA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

      CALL MNEWTON(I,J,TM(I,J),PM(I,J),DENSOM(I,J),DENSOMSNT(I,J)
     &     ,homSNT(I,J),PMSNT(I,J),et,H2m(I,J),ROm(I,J),TME(I,J))

         END DO
      END DO

C      STOP
       
        DO J=1,NY
	     DO I=1,NX
	       WRITE(7,*) I,J,TE(I,J),TME(I,J)
	       WRITE(9,*)I,J,RO(I,J),ROm(I,J)
	     END DO
        END DO
C	STOP
C  ___________________________________________________________________
C  --  CONDICIONES DE FRONTERA
C  --  PARA LA CELDA 1,1
C  ___________________________________________________________________
       
C  -- CALCULO DE LA PRESION EN LAS FRONTERAS DE LAS CELDAS
C  -- CON INTERPOLACIN LINEAL
      DO J=1,NY
       V=(5.615*GVO(1,J))/AR(1,J)
       P12R(1,J)=P(1,J)+(((P(2,J)-P(1,J))/(R(2,J)-R(1,J)))
     & *(R12(2,J)-R(1,J)))
C        P01R(1,J)=P(1,J)-(((P12R(1,J)-P(1,J))/(R12(2,J)-R(1,J)))
C     & *(R12(2,J)-R(1,J)))
	 P01R(1,J)=P(1,J)+(6.3265E-3*(MUO(1,J)/PERMR)*V*(R(1,J)-R12(1,J)))
	 P12R(NX,J)=P(NX,J)+(((P(NX,J)-P12R(NX-1,J))/(R(NX,J)-R12(NX,J)))
     & *(RE-R(NX,J)))
C      WRITE(7,*) P01R(1,J),P12R(1,J)
      END DO

	DO I=1,NX
	  P01Z(I,1)=P(I,1)!-(CONSPOT*PESPO*Z(I,1))
        P12Z(I,1)=P(I,1)+(((P(I,2)-P(I,1))/(Z(I,2)-Z(I,1)))
     &  *(Z12(I,2)-Z(I,1)))
        P12Z(I,NY)=P(I,NY)+(((P(I,NY)-P12Z(I,NY-1))/(Z(I,NY)-Z12(I,NY)))
     &    *(ESPE-Z(I,NY)))
C	WRITE(7,*) P01Z(I,1),P12Z(I,NY),P12Z(I,1)
	END DO
      
C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS
           AA(1,1)=(((LOOR(1,1)*ho(1,1)*0.5*AR(2,1))/(R(2,1)-R(1,1)))
     &            *(P(2,1)-P(1,1)))
     &            -(((LOOR(1,1)*ho(1,1)*0.5*AR(1,1))/(R(1,1)-RW))
     &            *(P(1,1)-P01R(1,1)))
C     &            -(qoaste(1,1)*ho(1,1))
     &            +(((LOOZ(1,1)*ho(1,1)*AZ(1,2))/(Z(1,2)-Z(1,1)))
     &            *(P(1,2)-P(1,1)-(PESPO*(Z(1,2)-Z(1,1))/144)))
     &            -(((LOOZ(1,1)*ho(1,1)*AZ(1,1))/(Z(1,1)-0.0))
     &            *(P(1,1)-P(1,1)-(PESPO*(Z(1,1)-0.0)/144)))
           A(1,1)=47.227E+06*AA(1,1)
C        WRITE(7,*) T(1,1),T(1,2)
C        WRITE(7,*) AR(1,1),AR(2,1)
C        WRITE(7,*) AZ(1,1),AZ(1,2)
       BB(1,1)=(((CTSRO*0.5*AR(2,1))/(R12(2,1)-R(1,1)))*(T(2,1)-T(1,1)))
     &      -(((CTSRO*0.5*AR(1,1))/(R(1,1)-0.0))*(T(1,1)-T(1,1)))
     &      +(((CTSRO*AZ(1,2))/(Z(1,2)-Z(1,1)))*(T(1,2)-T(1,1)))
     &      -(((CTSRO*AZ(1,1))/(Z(1,1)-0.0))*(T(1,1)-TFRIA))
           B(1,1)=4.4856E+15*BB(1,1)

      CALL INTER(NPUNTOS,PT,BOT,P(1,1),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(1,1),YMUO,DMUO)
           MUO(1,1)=YMUO
	     BO(1,1)=YBO
C      WRITE(7,*) P01R(1,1),P12R(1,1)
C	WRITE(7,*) P01Z(1,1),P12Z(1,1)
           CC(1,1)=(((PERMR*VR(1,1))/(MUO(1,1)*BO(1,1)))
     & *(((P12R(1,1)-P01R(1,1))/(R12(2,1)-R12(1,1)))**2))
     & +(((PERMZ*VR(1,1))/(MUO(1,1)*BO(1,1)))
     & *((((P12Z(1,1)-P01Z(1,1))/(Z12(1,2)-0.0))**2)
     & -((PESPO/144)*((P12Z(1,1)-P01Z(1,1))/(Z12(1,2)-0.0)))))
           C(1,1)=6800.7E+06*CC(1,1)

           DD(1,1)=LAMBDAOO(1,1)*hot(1,1)*(POTM(1,1)-POT(1,1))
           D(1,1)=47.227E+06*DD(1,1)
           EE(1,1)=EPSILO(1,1)*(TM(1,1)-T(1,1))
           E(1,1)=44.856E+14*EE(1,1)
           F(1,1)=QoAST(1,1)
           G(1,1)=74.6496E+08*qoaste(1,1)*ho(1,1)
           H(1,1)=A(1,1)+B(1,1)-C(1,1)+D(1,1)+E(1,1)-F(1,1)-G(1,1)

C           WRITE(7,*) '                                  '
C           WRITE(7,*) A(1,1)
C           WRITE(7,*) B(1,1),C(1,1),D(1,1)
C           WRITE(7,*) E(1,1),F(1,1),G(1,1)
C           WRITE(7,*) H(1,1),H1(1,1),H2(1,1)
C           WRITE(7,*) H(1,1)
C           WRITE(7,*) '                                  '
	

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA
       
	CALL INTER(NPUNTOS,PT,DENT,PSNT(1,1),DENSOSNT(1,1),DDENSOSNT)
	 COMDEN(1,1)=PORO*DENSOSNT(1,1)
	 PERTER=(DELTAt*H(1,1))/(74.6496E+08*VR(1,1)*COMDEN(1,1))
	 SDOTER=(1.075E+12*(P(1,1)-PSNT(1,1)))/(74.6496E+08*COMDEN(1,1))
	 TERTER=(PORO*ho(1,1)*DENSO(1,1))/(COMDEN(1,1))
	     hoSNT(1,1)=PERTER-SDOTER+TERTER
             H2(1,1)=hoSNT(1,1)-ho(1,1)

      CALL MNEWTON(1,1,T(1,1),P(1,1),DENSO(1,1),DENSOSNT(1,1),hoSNT(1,1)
     &     ,PSNT(1,1),et,H2(1,1),RO(1,1),TE(1,1))

C           T(I,J)=TITER(NK)
C           WRITE(7,*)'T = ',T(1,1)
       
C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(1,1)=-(D(1,1)+E(1,1))

	 CALL INTER(NPUNTOS,PT,DENT,PMSNT(1,1),DENSOMSNT(1,1),DDENSOMSNT)
	 COMDEN(1,1)=POROM*DENSOMSNT(1,1)
	 PERTER=(DELTAt*Hm(1,1))/(74.6496E+08*VR(1,1)*COMDEN(1,1))
	 SDOTER=(1.075E+12*(PM(1,1)-PMSNT(1,1)))/(74.6496E+08*COMDEN(1,1))
	 TERTER=(POROM*hom(1,1)*DENSOM(1,1))/(COMDEN(1,1))
	     homSNT(1,1)=PERTER-SDOTER+TERTER
             H2m(1,1)=homSNT(1,1)-hom(1,1)

      CALL MNEWTON(1,1,TM(1,1),PM(1,1),DENSOM(1,1),DENSOMSNT(1,1)
     &     ,homSNT(1,1),PMSNT(1,1),et,H2m(1,1),ROm(1,1),TME(1,1))
           WRITE(7,*)1,1,TE(1,1),TME(1,1)
           WRITE(9,*)1,1,RO(1,1),ROm(1,1)
C       STOP  
C  __________________________________________________________________________
C  --  PARA LAS CELDAS DESDE I=2 HASTA NX-1 , (I,1)
C  __________________________________________________________________________
C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS

         DO I=2,NX-1
           AA(I,1)=(((LOOR(I,1)*ho(I,1)*AR(I+1,1))/(R(I+1,1)-R(I,1)))
     &            *(P(I+1,1)-P(I,1)))
     &            -(((LOOR(I,1)*ho(I,1)*AR(I,1))/(R(I,1)-R(I-1,1)))
     &            *(P(I,1)-P(I-1,1)))
     &            +(((LOOZ(I,1)*ho(I,1)*AZ(I,2))/(Z(I,2)-Z(I,1)))
     &            *(P(I,2)-P(I,1)-(PESPO*(Z(I,2)-Z(I,1))/144)))
     &            -(((LOOZ(I,1)*ho(I,1)*AZ(I,1))/(Z(I,1)-0.0))
     &            *(P(I,1)-P(I,1)-(PESPO*(Z(I,1)-0.0)/144)))
           A(I,1)=47.227E+06*AA(I,1)

       BB(I,1)=(((CTSRO*AR(I+1,1))/(R(I+1,1)-R(I,1)))*(T(I+1,1)-T(I,1)))
     &      -(((CTSRO*AR(I,1))/(R(I,1)-R(I-1,1)))*(T(I,1)-T(I-1,1)))
     &      +(((CTSRO*AZ(I,2))/(Z(I,2)-Z(I,1)))*(T(I,2)-T(I,1)))
     &      -(((CTSRO*AZ(I,1))/(Z(I,1)-0.0))*(T(I,1)-TFRIA))
           B(I,1)=4.4856E+15*BB(I,J)

      CALL INTER(NPUNTOS,PT,BOT,P(I,1),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(I,1),YMUO,DMUO)
           MUO(I,1)=YMUO
	     BO(I,1)=YBO
           CC(I,1)=(((PERMR*VR(I,1))/(MUO(I,1)*BO(I,1)))
     & *(((P12R(I,1)-P01R(I,1))/(R12(I+1,1)-R12(I,1)))**2))
     & +(((PERMZ*VR(I,1))/(MUO(I,1)*BO(I,1)))
     & *((((P12Z(I,1)-P01Z(I,1))/(Z12(I,2)-Z12(I,1)))**2)
     & -((PESPO/144)*((P12Z(I,1)-P01Z(I,1))/(Z12(I,2)-Z12(I,1))))))
           C(I,1)=6800.7E+06*CC(I,1)

           DD(I,1)=LAMBDAOO(I,1)*hot(I,1)*(POTM(I,1)-POT(I,1))
           D(I,1)=47.227E+06*DD(I,1)
           EE(I,1)=EPSILO(I,1)*(TM(I,1)-T(I,1))
           E(I,1)=44.856E+14*EE(I,1)
           F(I,1)=QoAST(I,1)
           G(I,1)=74.6496E+08*qoaste(I,1)*ho(I,1)
           H(I,1)=A(I,1)+B(I,1)-C(I,1)+D(I,1)+E(I,1)-F(I,1)-G(I,1)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA
	CALL INTER(NPUNTOS,PT,DENT,PSNT(I,1),DENSOSNT(I,1),DDENSOSNT)
	 COMDEN(I,1)=PORO*DENSOSNT(I,1)
	 PERTER=(DELTAt*H(I,1))/(74.6496E+08*VR(I,1)*COMDEN(I,1))
	 SDOTER=(1.075E+12*(P(I,1)-PSNT(I,1)))/(74.6496E+08*COMDEN(I,1))
	 TERTER=(PORO*ho(I,1)*DENSO(I,1))/(COMDEN(I,1))
	     hoSNT(I,1)=PERTER-SDOTER+TERTER
             H2(I,1)=hoSNT(I,1)-ho(I,1)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ
           Hm(I,1)=-(D(1,1)+E(1,1))

	 CALL INTER(NPUNTOS,PT,DENT,PMSNT(I,1),DENSOMSNT(I,1),DDENSOMSNT)
	 COMDEN(I,1)=POROM*DENSOMSNT(I,1)
	 PERTER=(DELTAt*Hm(I,1))/(74.6496E+08*VR(I,1)*COMDEN(I,1))
	 SDOTER=(1.075E+12*(PM(I,1)-PMSNT(I,1)))/(74.6496E+08*COMDEN(I,1))
	 TERTER=(POROM*hom(I,1)*DENSOM(I,1))/(COMDEN(I,1))
	     homSNT(I,1)=PERTER-SDOTER+TERTER
             H2m(I,1)=homSNT(I,1)-hom(I,1)

C           WRITE(7,*) A(I,1)
C           WRITE(7,*) B(I,1),C(I,1),D(I,1)
C           WRITE(7,*) E(I,1),F(I,1),G(I,1)
C           WRITE(7,*) H(I,1),H1(I,1),H2(I,1)
C           WRITE(7,*) I,J,H2(I,J)
       END DO

	  DO I=2,NX-1

      CALL MNEWTON(I,1,T(I,1),P(I,1),DENSO(I,1),DENSOSNT(I,1),hoSNT(I,1)
     &     ,PSNT(I,1),et,H2(I,1),RO(I,1),TE(I,1))

      CALL MNEWTON(I,1,TM(I,1),PM(I,1),DENSOM(I,1),DENSOMSNT(I,1)
     &     ,homSNT(I,1),PMSNT(I,1),et,H2m(I,1),ROm(I,1),TME(I,1))

           WRITE(7,*)I,1,TE(I,1),TME(I,1)
           WRITE(9,*)I,1,RO(I,1),ROm(I,1)
	  END DO
C          STOP
C  __________________________________________________________________________
C  --  PARA LA CELDA NX,1
C  __________________________________________________________________________
C  -- CALCULO DE LA PRESIN EN LAS FRONTERAS DE LAS CELDAS(2,NX-1 Y 2,NY-1)
C  -- CON INTERPOLACIN LINEAL

      P12R(NX-1,1)=P(NX-1,1)+(((P(NX,1)-P(NX-1,1))/(R(NX,1)-R(NX-1,1)))
     &*(R12(NX,1)-R(NX-1,1)))
      P01R(NX,1)= P12R(NX-1,1)
       P12R(NX,1)=P(NX,1)+(((P(NX,1)-P12R(NX-1,1))/(R(NX,1)-R12(NX,1)))
     & *(RE-R(NX,1)))

C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS

           AA(NX,1)=(((LOOR(NX,1)*ho(NX,1)*AR(NX+1,1))/(RE-R(NX,1)))
     &            *(P(NX,1)-P(NX,1)))
     &            -(((LOOR(NX,1)*ho(NX,1)*AR(NX,1))/(R(NX,1)-R(NX-1,1)))
     &            *(P(NX,1)-P(NX-1,1)))
     &            +(((LOOZ(NX,1)*ho(NX,1)*AZ(NX,2))/(Z(NX,2)-Z(NX,1)))
     &            *(P(NX,2)-P(NX,1)-(PESPO*(Z(NX,2)-Z(NX,1))/144)))
     &            -(((LOOZ(NX,1)*ho(NX,1)*AZ(NX,1))/(Z(NX,1)-0.0))
     &            *(P(NX,1)-P(NX,1)-(PESPO*(Z(NX,1)-0.0)/144)))
           A(NX,1)=47.227E+06*AA(NX,1)
C        WRITE(7,*) AR(NX,1),AR(NX+1,1)
      BB(NX,1)=(((CTSRO*AR(NX+1,1))/(RE-R(NX,1)))*(T(NX,1)-T(NX,1)))
     &-(((CTSRO*AR(NX,1))/(R(NX,1)-R(NX-1,1)))*(T(NX-1,1)-T(NX-1,1)))
     &+(((CTSRO*AZ(NX,2))/(Z(NX,2)-Z(NX,1)))*(T(NX,2)-T(NX,1)))
     &-(((CTSRO*AZ(NX,1))/(Z(NX,1)-0.0))*(T(NX,1)-TFRIA))
         B(NX,1)=4.4856E+15*BB(NX,1)

      CALL INTER(NPUNTOS,PT,BOT,P(NX,1),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(NX,1),YMUO,DMUO)
           MUO(NX,1)=YMUO
	     BO(NX,1)=YBO
C        WRITE(7,*) P01R(NX,1),P12R(NX,1)
C        WRITE(7,*) P01Z(NX,1),P12Z(NX,1)
       CC(NX,1)=(((PERMR*VR(NX,1))/(MUO(NX,1)*BO(NX,1)))
     & *(((P12R(NX,1)-P01R(NX,1))/(RE-R12(NX,1)))**2))
     & +(((PERMZ*VR(NX,1))/(MUO(NX,1)*BO(NX,1)))
     & *((((P12Z(NX,1)-P01Z(NX,1))/(Z12(NX,2)-Z12(NX,1)))**2)
     & -((PESPO/144)*((P12Z(NX,1)-P01Z(NX,1))/(Z12(NX,2)-Z12(NX,1))))))
           C(NX,1)=6800.7E+06*CC(NX,1)

       DD(NX,1)=LAMBDAOO(NX,1)*hot(NX,1)*(POTM(NX,1)-POT(NX,1))
       D(NX,1)=47.227E+06*DD(NX,1)
       EE(NX,1)=EPSILO(NX,1)*(TM(NX,1)-T(NX,1))
       E(NX,1)=44.856E+14*EE(NX,1)
       F(NX,1)=QoAST(NX,1)
       G(NX,1)=74.6496E+08*qoaste(NX,1)*ho(NX,1)
       H(NX,1)=A(NX,1)+B(NX,1)-C(NX,1)+D(NX,1)+E(NX,1)-F(NX,1)-G(NX,1)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

	CALL INTER(NPUNTOS,PT,DENT,PSNT(NX,1),DENSOSNT(NX,1),DDENSOSNT)
	COMDEN(NX,1)=PORO*DENSOSNT(NX,1)
	PERTER=(DELTAt*H(NX,1))/(74.6496E+08*VR(NX,1)*COMDEN(NX,1))
	SDOTER=(1.075E+12*(P(NX,1)-PSNT(NX,1)))/(74.6496E+08*COMDEN(NX,1))
	TERTER=(PORO*ho(NX,1)*DENSO(NX,1))/(COMDEN(NX,1))
	     hoSNT(NX,1)=PERTER-SDOTER+TERTER
             H2(NX,1)=hoSNT(NX,1)-ho(NX,1)

      CALL MNEWTON(NX,1,T(NX,1),P(NX,1),DENSO(NX,1),DENSOSNT(NX,1),
     &     hoSNT(NX,1),PSNT(NX,1),et,H2(NX,1),RO(NX,1),TE(NX,1))

C           WRITE(7,*) A(NX,1)
C           WRITE(7,*) B(NX,1),C(NX,1),D(NX,1)
C           WRITE(7,*) E(NX,1),F(NX,1),G(NX,1)
C           WRITE(7,*) H(NX,1),H1(NX,1),H2(NX,1)
C           WRITE(7,*) NX,1,H2(NX,1)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(NX,1)=-(D(NX,1)+E(NX,1))

	CALL INTER(NPUNTOS,PT,DENT,PMSNT(NX,1),DENSOMSNT(NX,1),DDENSOMSNT)
	COMDEN(NX,1)=POROM*DENSOMSNT(NX,1)
	PERTER=(DELTAt*Hm(NX,1))/(74.6496E+08*VR(NX,1)*COMDEN(NX,1))
	SDOTER=(1.075E+12*(PM(NX,1)-PMSNT(NX,1)))/(74.6496E+08
     &       *COMDEN(NX,1))
	TERTER=(POROM*hom(NX,1)*DENSOM(NX,1))/(COMDEN(NX,1))
	     homSNT(NX,1)=PERTER-SDOTER+TERTER
             H2m(NX,1)=homSNT(NX,1)-hom(NX,1)

      CALL MNEWTON(NX,1,TM(NX,1),PM(NX,1),DENSOM(NX,1),DENSOMSNT(NX,1)
     &     ,homSNT(NX,1),PMSNT(NX,1),et,H2m(NX,1),ROm(NX,1),TME(NX,1))

           WRITE(7,*)NX,1,TE(NX,1),TME(NX,1)
           WRITE(9,*)NX,1,RO(NX,1),ROm(NX,1)
C      STOP	         
C  __________________________________________________________________________
C  --  PARA LAS CELDAS DESDE I=2 HASTA NX-1 , (I,NY)
C  __________________________________________________________________________
C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS

      DO I=2,NX-1
        P01R(I,NY)=P(I-1,NY)+(((P(I,NY)-P(I-1,NY))/(R(I,NY)-R(I-1,NY)))
     &  *(R12(I,NY)-R(I-1,NY)))
        P12R(I,NY)=P(I,NY)+(((P(I+1,NY)-P(I,NY))/(R(I+1,NY)-R(I,NY)))
     &  *(R12(I+1,NY)-R(I,NY)))
        P01Z(I,NY)=P(I,NY-1)+(((P(I,NY)-P(I,NY-1))/(Z(I,NY)-Z(I,NY-1)))
     &  *(Z12(I,NY)-Z(I,NY-1)))
        P12Z(I,NY)=P(I,NY)+(((P(I,NY)-P(I,NY))/(Z(I,NY+1)-Z(I,NY)))
     &  *(Z12(I,NY+1)-Z(I,NY)))
C      WRITE(7,*) P01R(I,J),P12R(I,J),P01Z(I,J)
      END DO

         DO I=2,NX-1
      AA(I,NY)=(((LOOR(I,NY)*ho(I,NY)*AR(I+1,NY))/(R(I+1,NY)-R(I,NY)))
     &         *(P(I+1,NY)-P(I,NY)))
     &         -(((LOOR(I,NY)*ho(I,NY)*AR(I,NY))/(R(I,NY)-R(I-1,NY)))
     &         *(P(I,NY)-P(I-1,NY)))
     &         +(((LOOZ(I,NY)*ho(I,NY)*AZ(I,NY+1))/(ESPE-Z(I,NY)))
     &         *(P(I,NY)-P(I,NY)-(PESPO*(ESPE-Z(I,NY))/144)))
     &         -(((LOOZ(I,NY)*ho(I,NY)*AZ(I,NY))/(Z(I,NY)-Z(I,NY-1)))
     &         *(P(I,NY)-P(I,NY-1)-(PESPO*(Z(I,NY)-Z(I,NY-1))/144)))
           A(I,NY)=47.227E+06*AA(I,NY)

       BB(I,NY)=(((CTSRO*AR(I+1,NY))/(R(I+1,NY)-R(I,NY)))
     & *(T(I+1,NY)-T(I,NY)))
     & -(((CTSRO*AR(I,NY))/(R(I,NY)-R(I-1,NY)))*(T(I,NY)-T(I-1,NY)))
     & +(((CTSRO*AZ(I,NY+1))/(ESPE-Z(I,NY)))*(TCALIENTE-T(I,NY)))
     & -(((CTSRO*AZ(I,NY))/(Z(I,NY)-Z(I,NY-1)))*(T(I,NY)-T(I,NY-1)))
           B(I,1)=4.4856E+15*BB(I,NY)

      CALL INTER(NPUNTOS,PT,BOT,P(I,NY),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(I,NY),YMUO,DMUO)
           MUO(I,NY)=YMUO
	     BO(I,NY)=YBO
           CC(I,NY)=(((PERMR*VR(I,NY))/(MUO(I,NY)*BO(I,NY)))
     & *(((P12R(I,NY)-P01R(I,NY))/(R12(I+1,NY)-R12(I,NY)))**2))
     & +(((PERMZ*VR(I,NY))/(MUO(I,NY)*BO(I,NY)))
     & *((((P12Z(I,NY)-P01Z(I,NY))/(Z12(I,NY+1)-Z12(I,NY)))**2)
     & -((PESPO/144)*((P12Z(I,NY)-P01Z(I,NY))/(Z12(I,NY+1)-Z12(I,NY))
     & ))))
           C(I,NY)=6800.7E+06*CC(I,NY)

           DD(I,NY)=LAMBDAOO(I,NY)*hot(I,NY)*(POTM(I,NY)-POT(I,NY))
           D(I,NY)=47.227E+06*DD(I,NY)
           EE(I,NY)=EPSILO(I,NY)*(TM(I,NY)-T(I,NY))
           E(I,NY)=44.856E+14*EE(I,NY)
           F(I,NY)=QoAST(I,NY)
           G(I,NY)=74.6496E+08*qoaste(I,NY)*ho(I,NY)
       H(I,NY)=A(I,NY)+B(I,NY)-C(I,NY)+D(I,NY)+E(I,NY)-F(I,NY)-G(I,NY)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

	CALL INTER(NPUNTOS,PT,DENT,PSNT(I,NY),DENSOSNT(I,NY),DDENSOSNT)
	 COMDEN(I,NY)=PORO*DENSOSNT(I,NY)
	 PERTER=(DELTAt*H(I,NY))/(74.6496E+08*VR(I,NY)*COMDEN(I,NY))
	SDOTER=(1.075E+12*(P(I,NY)-PSNT(I,NY)))/(74.6496E+08*COMDEN(I,NY))
	TERTER=(PORO*ho(I,NY)*DENSO(I,NY))/(COMDEN(I,NY))
	     hoSNT(I,NY)=PERTER-SDOTER+TERTER
             H2(I,NY)=hoSNT(I,NY)-ho(I,NY)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(I,NY)=-(D(I,NY)+E(I,NY))

	 CALL INTER(NPUNTOS,PT,DENT,PMSNT(I,NY),DENSOMSNT(I,NY),DDENSOMSNT)
	 COMDEN(I,NY)=POROM*DENSOMSNT(I,NY)
	 PERTER=(DELTAt*Hm(I,NY))/(74.6496E+08*VR(I,NY)*COMDEN(I,NY))
	 SDOTER=(1.075E+12*(PM(I,NY)-PMSNT(I,NY)))/(74.6496E+08
     &        *COMDEN(I,NY))
	 TERTER=(POROM*hom(I,NY)*DENSOM(I,NY))/(COMDEN(I,NY))
	     homSNT(I,NY)=PERTER-SDOTER+TERTER
             H2m(I,NY)=homSNT(I,NY)-hom(I,NY)
C           WRITE(7,*) A(I,NY)
C           WRITE(7,*) B(I,NY),C(I,NY),D(I,NY)
C           WRITE(7,*) E(I,NY),F(I,NY),G(I,NY)
C           WRITE(7,*) H(I,NY),H1(I,NY),H2(I,NY)
C           WRITE(7,*) I,NY,H2(I,NY)
       END DO

	  DO I=2,NX-1
      CALL MNEWTON(I,NY,T(I,NY),P(I,NY),DENSO(I,NY),DENSOSNT(I,NY),
     &     hoSNT(I,NY),PSNT(I,NY),et,H2(I,NY),RO(I,NY),TE(I,NY))

      CALL MNEWTON(I,NY,TM(I,NY),PM(I,NY),DENSOM(I,NY),DENSOMSNT(I,NY)
     &     ,homSNT(I,NY),PMSNT(I,NY),et,H2m(I,NY),ROm(I,NY),TME(I,NY))

           WRITE(7,*)I,NY,TE(I,NY),TME(I,NY)
           WRITE(9,*)I,NY,RO(I,NY),ROm(I,NY)
         END DO
C      STOP
C  __________________________________________________________________________
C  --  PARA LAS CELDAS DESDE J=2 HASTA NY-1 , (1,J)
C  __________________________________________________________________________
C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS
      DO J=2,NY-1
       V=(5.615*GVO(1,J))/AR(1,J)
       P12R(1,J)=P(1,J)+(((P(2,J)-P(1,J))/(R(2,J)-R(1,J)))
     & *(R12(2,J)-R(1,J)))
	 P01R(1,J)=P(1,J)+(6.3265E-3*(MUO(1,J)/PERMR)*V*(R(1,J)-R12(1,J)))
      P01Z(1,J)=P(1,J-1)+(((P(1,J)-P(1,J-1))/(Z(1,J)-Z(1,J-1)))
     & *(Z12(1,J)-Z(1,J-1)))
      P12Z(1,J)=P(1,J)+(((P(1,J+1)-P(1,J))/(Z(1,J+1)-Z(1,J)))
     & *(Z12(1,J+1)-Z(1,J)))
      END DO
       
      DO J=2,NY-1
      AA(1,J)=(((LOOR(1,J)*ho(1,J)*AR(2,J))/(R(2,J)-R(1,J)))
     &        *(P(2,J)-P(1,J)))
     &        -(((LOOR(1,J)*ho(1,J)*AR(1,J))/(R(1,J)-0.0))
     &        *(P(1,J)-P01R(1,J)))
     &        +(((LOOZ(1,J)*ho(1,J)*AZ(1,J+1))/(Z(1,J+1)-Z(1,J)))
     &        *(P(1,J+1)-P(1,J)-(PESPO*(Z(1,J+1)-Z(1,J))/144)))
     &        -(((LOOZ(1,J)*ho(1,J)*AZ(1,J))/(Z(1,J)-Z(1,J-1)))
     &        *(P(1,J)-P(1,J-1)-(PESPO*(Z(1,J)-Z(1,J-1))/144)))
      A(1,J)=47.227E+06*AA(1,J)

C       BB(1,J)=(((CTSRO*AR(2,J))/(R(2,J)-R(1,J)))*(T(2,J)-T(1,J)))
C     & -(((CTSRO*AR(1,J))/(R(1,J)-0.0))*(T(1,J)-GRADT(1,J)))
C     & +(((CTSRO*AZ(1,J+1))/(Z(1,J+1)-Z(1,J)))*(T(1,J+1)-T(1,J)))
C     & -(((CTSRO*AZ(1,J))/(Z(1,J)-Z(1,J-1)))*(T(1,J)-T(1,J-1)))
C           B(1,J)=4.4856E+15*BB(1,J)

       BB(1,J)=(((CTSRO*AR(2,J))/(R12(2,J)-R(1,J)))*(T(1,J)-T(1,J)))
     &      -(((CTSRO*AR(1,J))/(R(1,J)-0.0))*(T(1,J)-T(1,J)))
     &      +(((CTSRO*AZ(1,J+1))/(Z(1,J+1)-Z(1,J)))*(T(1,J+1)-T(1,J)))
     &      -(((CTSRO*AZ(1,J))/(Z(1,J)-Z(I,J-1))*(T(1,J)-GRADT(1,J-1))))
           B(1,J)=4.4856E+15*BB(1,J)

C           WRITE(7,*) '                                          '
C           WRITE(7,*) (T(1,J+1)-T(1,J)),(T(1,J)-GRADT(1,J-1))
C      _____AQUI LO COMPARE CON LA CELDA (1,1) PARA VER COMO ESTA EL CALCULO 
C       BB(1,1)=(((CTSRO*AR(2,1))/(R12(2,1)-R(1,1)))*(T(2,1)-T(1,1)))
C     &      -(((CTSRO*AR(1,1))/(R(1,1)-0.0))*(T(1,1)-T(1,1)))
C     &      +(((CTSRO*AZ(1,2))/(Z(1,2)-Z(1,1)))*(T(1,2)-T(1,1)))
C     &      -(((CTSRO*AZ(1,1))/(Z(1,1)-0.0))*(T(1,1)-TFRIA))
C           B(1,1)=4.4856E+15*BB(1,1)

      CALL INTER(NPUNTOS,PT,BOT,P(1,J),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(1,J),YMUO,DMUO)
           MUO(1,J)=YMUO
	     BO(1,J)=YBO
           CC(1,J)=(((PERMR*VR(1,J))/(MUO(1,J)*BO(1,J)))
     &*(((P12R(1,J)-P01R(1,J))/(R12(2,J)-R12(1,J)))**2))
     &+(((PERMZ*VR(1,J))/(MUO(1,J)*BO(1,J)))
     &*((((P12Z(1,J)-P01Z(1,J))/(Z12(1,J+1)-Z12(1,J)))**2)
     &-((PESPO/144)*((P12Z(1,J)-P01Z(1,J))/(Z12(1,J+1)-Z12(1,J))))))
           C(1,J)=6800.7E+06*CC(1,J)

       DD(1,J)=LAMBDAOO(1,J)*hot(1,J)*(POTM(1,J)-POT(1,J))
       D(1,J)=47.227E+06*DD(1,J)
       EE(1,J)=EPSILO(1,J)*(TM(1,J)-T(1,J))
       E(1,J)=44.856E+14*EE(1,J)
       F(1,J)=QoAST(1,J)
       G(1,J)=74.6496E+08*qoaste(1,J)*ho(1,J)
       H(1,J)=A(1,J)+B(1,J)-C(1,J)+D(1,J)+E(1,J)-F(1,J)-G(1,J)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

	CALL INTER(NPUNTOS,PT,DENT,PSNT(1,J),DENSOSNT(1,J),DDENSOSNT)
	 COMDEN(1,J)=PORO*DENSOSNT(1,J)
	 PERTER=(DELTAt*H(1,J))/(74.6496E+08*VR(1,J)*COMDEN(1,J))
	SDOTER=(1.075E+12*(P(1,J)-PSNT(1,J)))/(74.6496E+08*COMDEN(1,J))
	TERTER=(PORO*ho(1,J)*DENSO(1,J))/(COMDEN(1,J))
	     hoSNT(1,J)=PERTER-SDOTER+TERTER
             H2(1,J)=hoSNT(1,J)-ho(1,J)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(1,J)=-(D(1,J)+E(1,J))

	 CALL INTER(NPUNTOS,PT,DENT,PMSNT(1,J),DENSOMSNT(1,J),DDENSOMSNT)
	 COMDEN(1,J)=POROM*DENSOMSNT(1,J)
	 PERTER=(DELTAt*Hm(1,J))/(74.6496E+08*VR(1,J)*COMDEN(1,J))
	 SDOTER=(1.075E+12*(PM(1,J)-PMSNT(1,J)))/(74.6496E+08
     &        *COMDEN(1,J))
	 TERTER=(POROM*hom(1,J)*DENSOM(1,J))/(COMDEN(1,J))
	     homSNT(1,J)=PERTER-SDOTER+TERTER
             H2m(1,J)=homSNT(1,J)-hom(1,J)
C           WRITE(7,*) '                               '
C           WRITE(7,*) A(1,J)
C           WRITE(7,*) B(1,J),C(1,J),D(1,J)
C           WRITE(7,*) E(1,J),F(1,J),G(1,J)
C           WRITE(7,*) H(1,J),H1(1,J),H2(1,J)
C           WRITE(7,*) '                               '
       END DO
C       STOP
         DO  J=2,NY-1

      CALL MNEWTON(1,J,T(1,J),P(1,J),DENSO(1,J),DENSOSNT(1,J),
     &     hoSNT(1,J),PSNT(1,J),et,H2(1,J),RO(1,J),TE(1,J))

      CALL MNEWTON(1,J,TM(1,J),PM(1,J),DENSOM(1,J),DENSOMSNT(1,J)
     &     ,homSNT(1,J),PMSNT(1,J),et,H2m(1,J),ROm(1,J),TME(1,J))

           WRITE(7,*)1,J,TE(1,J),TME(1,J)
           WRITE(9,*)1,J,RO(1,J),ROm(1,J)
         END DO
C	STOP
C  ___________________________________________________________________
C  --  CONDICIONES DE FRONTERA
C  --  PARA LA CELDA 1,NY
C  ___________________________________________________________________
       
C  -- CALCULO DE LA PRESION EN LAS FRONTERAS DE LAS CELDAS
C  -- CON INTERPOLACIN LINEAL
       V=(5.615*GVO(1,NY))/AR(1,NY)
       P12R(1,NY)=P(1,NY)+(((P(2,NY)-P(1,NY))/(R(2,NY)-R(1,NY)))
     & *(R12(2,NY)-R(1,NY)))
	 P01R(1,NY)=P(1,NY)+(6.3265E-3*(MUO(1,NY)/PERMR)*V*
     & (R(1,NY)-R12(1,NY)))
C       TCALIENTE=0.01463*ESPE+TFRIA 
      P01Z(1,NY)=P(1,NY-1)+(((P(1,J)-P(1,NY-1))/(Z(1,NY)-Z(1,NY-1)))
     & *(Z12(1,NY)-Z(1,NY-1)))
      P12Z(1,NY)=P(1,NY)+(((P(1,NY)-P(1,NY))/(Z(1,NY+1)-Z(1,NY)))
     & *(Z12(1,NY+1)-Z(1,NY)))

      
C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS
           AA(1,NY)=(((LOOR(1,NY)*ho(1,NY)*AR(2,NY))/(R(2,NY)-R(1,NY)))
     &            *(P(2,NY)-P(1,NY)))
     &            -(((LOOR(1,NY)*ho(1,NY)*AR(1,NY))/(R(1,NY)-0.0))
     &            *(P(1,NY)-P01R(1,NY)))
     &            +(((LOOZ(1,NY)*ho(1,NY)*AZ(1,NY+1))/(ESPE-Z(1,NY)))
     &            *(P(1,NY)-P(1,NY)-(PESPO*(ESPE-Z(1,NY))/144)))
     &            -(((LOOZ(1,NY)*ho(1,NY)*AZ(1,NY))/(Z(1,NY)-Z(1,NY-1)))
     &            *(P(1,NY)-P(1,NY-1)-(PESPO*(Z(1,NY)-Z(1,NY-1))/144)))
           A(1,NY)=47.227E+06*AA(1,NY)

C       BB(1,NY)=
C     &(((CTSRO*AR(2,NY))/(R12(2,NY)-R(1,NY)))*(GRADT(2,NY)-T(1,NY)))
C     &-(((CTSRO*AR(1,NY))/(R(1,NY)-0.0))*(T(1,NY)-GRADT(1,NY)))
C     &+(((CTSRO*AZ(1,NY+1))/(ESPE-Z(1,NY)))*(TCALIENTE-T(1,NY)))
C     &-(((CTSRO*AZ(1,NY))/(Z(1,NY)-Z(1,NY-1)))*(T(1,NY)-GRADT(1,NY-1))) !OJO NO CONOZCO AN T(1,NY-1)
C           B(1,NY)=4.4856E+15*BB(1,NY)  !BUSCO T(1,NY) LA DE ARRIBA ES REALMENTE GRADT(1,NY)

       BB(1,NY)=
     &(((CTSRO*AR(2,NY))/(R(2,NY)-R(1,NY)))*(GRADT(2,NY)-T(1,NY)))
     &-(((CTSRO*AR(1,NY))/(R(1,NY)-0.0))*(T(1,NY)-GRADT(1,NY)))
     &+(((CTSRO*AZ(1,NY+1))/(ESPE-Z(1,NY)))*(TCALIENTE-T(1,NY)))
     &-(((CTSRO*AZ(1,NY))/(Z(1,NY)-Z(1,NY-1)))*(T(1,NY)-GRADT(1,NY-1))) !OJO NO CONOZCO AN T(1,NY-1)
           B(1,NY)=4.4856E+15*BB(1,NY)  !BUSCO T(1,NY) LA DE ARRIBA ES REALMENTE GRADT(1,NY)
C           WRITE(7,*) '                                          '
C           WRITE(7,*) T(1,NY)-GRADT(1,NY-1)

C       BB(I,NY)=(((CTSRO*AR(I+1,NY))/(R(I+1,NY)-R(I,NY)))
C     & *(T(I+1,NY)-T(I,NY)))
C     & -(((CTSRO*AR(I,NY))/(R(I,NY)-R(I-1,NY)))*(T(I,NY)-T(I-1,NY)))
C     & +(((CTSRO*AZ(I,NY+1))/(ESPE-Z(I,NY)))*(TCALIENTE-T(I,NY)))
C     & -(((CTSRO*AZ(I,NY))/(Z(I,NY)-Z(I,NY-1)))*(T(I,NY)-T(I,NY-1)))
C           B(I,1)=4.4856E+15*BB(I,NY)


      CALL INTER(NPUNTOS,PT,BOT,P(1,NY),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(1,NY),YMUO,DMUO)
           MUO(1,NY)=YMUO
	     BO(1,NY)=YBO

           CC(1,NY)=(((PERMR*VR(1,NY))/(MUO(1,NY)*BO(1,NY)))
     &*(((P12R(1,NY)-P01R(1,NY))/(R12(2,NY)-R12(1,NY)))**2))
     &+(((PERMZ*VR(1,NY))/(MUO(1,NY)*BO(1,NY)))
     &*((((P12Z(1,NY)-P01Z(1,NY))/(ESPE-Z12(1,NY)))**2)
     &-((PESPO/144)*((P12Z(1,NY)-P01Z(1,NY))/(ESPE-Z12(1,NY))))))
           C(1,NY)=6800.7E+06*CC(1,NY)

       DD(1,NY)=LAMBDAOO(1,NY)*hot(1,NY)*(POTM(1,NY)-POT(1,NY))
       D(1,NY)=47.227E+06*DD(1,NY)
       EE(1,NY)=EPSILO(1,NY)*(TM(1,NY)-T(1,NY))
       E(1,NY)=44.856E+14*EE(1,NY)
       F(1,NY)=QoAST(1,NY)
       G(1,NY)=74.6496E+08*qoaste(1,NY)*ho(1,NY)
       H(1,NY)=A(1,NY)+B(1,NY)-C(1,NY)+D(1,NY)+E(1,NY)-F(1,NY)-G(1,NY)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

	CALL INTER(NPUNTOS,PT,DENT,PSNT(1,NY),DENSOSNT(1,NY),DDENSOSNT)
	 COMDEN(1,NY)=PORO*DENSOSNT(1,NY)
	 PERTER=(DELTAt*H(1,NY))/(74.6496E+08*VR(1,NY)*COMDEN(1,NY))
	SDOTER=(1.075E+12*(P(1,NY)-PSNT(1,NY)))/(74.6496E+08*COMDEN(1,NY))
	 TERTER=(PORO*ho(1,NY)*DENSO(1,NY))/(COMDEN(1,NY))
	     hoSNT(1,NY)=PERTER-SDOTER+TERTER
             H2(1,NY)=hoSNT(1,NY)-ho(1,NY)

      CALL MNEWTON(1,NY,T(1,NY),P(1,NY),DENSO(1,NY),DENSOSNT(1,NY),
     &     hoSNT(1,NY),PSNT(1,NY),et,H2(1,NY),RO(1,NY),TE(1,NY))
C           WRITE(7,*) '                                          '
C           WRITE(7,*) A(1,NY)
C           WRITE(7,*) B(1,NY),C(1,NY),D(1,NY)
C           WRITE(7,*) E(1,NY),F(1,NY),G(1,NY)
C           WRITE(7,*) H(1,NY),H1(1,NY),H2(1,NY)
C           WRITE(7,*) H(1,NY)
C           WRITE(7,*) '                                          '

       
C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(1,NY)=-(D(1,NY)+E(1,NY))

	 CALL INTER(NPUNTOS,PT,DENT,PMSNT(1,NY),DENSOMSNT(1,NY),DDENSOMSNT)
	 COMDEN(1,NY)=POROM*DENSOMSNT(1,NY)
	 PERTER=(DELTAt*Hm(1,NY))/(74.6496E+08*VR(1,NY)*COMDEN(1,NY))
	 SDOTER=(1.075E+12*(PM(1,NY)-PMSNT(1,NY)))/(74.6496E+08
     &        *COMDEN(1,NY))
	 TERTER=(POROM*hom(1,NY)*DENSOM(1,NY))/(COMDEN(1,NY))
	     homSNT(1,NY)=PERTER-SDOTER+TERTER
             H2m(1,NY)=homSNT(1,NY)-hom(1,NY)

      CALL MNEWTON(1,NY,TM(1,NY),PM(1,NY),DENSOM(1,NY),DENSOMSNT(1,NY)
     &     ,homSNT(1,NY),PMSNT(1,NY),et,H2m(1,NY),ROm(1,NY),TME(1,NY))

           WRITE(7,*)1,NY,T(1,NY),TME(1,NY)
           WRITE(9,*)1,NY,RO(1,NY),ROm(1,NY)
C      STOP
C  __________________________________________________________________________
C  __________________________________________________________________________
C  ________________________  PARA LAS CELDAS DE ABAJO  ______________________
      


C  __________________________________________________________________________
C  --  PARA LAS CELDAS DESDE J=2 HASTA NY-1 , (NX,J)
C  __________________________________________________________________________
C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS

      DO J=2,NY-1
      P12R(NX-1,J)=P(NX-1,J)+(((P(NX,J)-P(NX-1,J))/(R(NX,J)-R(NX-1,J)))
     &*(R12(NX,J)-R(NX-1,J)))
      P01R(NX,J)= P12R(NX-1,J)
       P12R(NX,J)=P(NX,J)+(((P(NX,J)-P12R(NX-1,J))/(R(NX,J)-R12(NX,J)))
     & *(RE-R(NX,J)))

       P01Z(NX,J)=P(NX,J-1)+(((P(NX,J)-P(NX,J-1))/(Z(NX,J)-Z(NX,J-1)))
     & *(Z12(NX,J)-Z(NX,J-1)))
       P12Z(NX,J)=P(NX,J)+(((P(NX,J+1)-P(NX,J))/(Z(NX,J+1)-Z(NX,J)))
     & *(Z12(NX,J+1)-Z(NX,J)))
C	 WRITE(7,*) P01R(NX,J),P12R(NX,J)  
C	 WRITE(7,*) P01Z(NX,J),P12Z(NX,J)  
      END DO


       
      DO J=2,NY-1
      AA(NX,J)=(((LOOR(NX,J)*ho(NX,J)*AR(NX+1,J))/(RE-R(NX,J)))
     &        *(P(NX,J)-P(NX,J)))
     &        -(((LOOR(NX,J)*ho(NX,J)*AR(NX,J))/(R(NX,J)-R(NX-1,J)))
     &        *(P(NX,J)-P(NX-1,J)))
     &        +(((LOOZ(NX,J)*ho(NX,J)*AZ(NX,J+1))/(Z(NX,J+1)-Z(NX,J)))
     &        *(P(NX,J+1)-P(NX,J)-(PESPO*(Z(NX,J+1)-Z(NX,J))/144)))
     &        -(((LOOZ(NX,J)*ho(NX,J)*AZ(NX,J))/(Z(NX,J)-Z(NX,J-1)))
     &        *(P(NX,J)-P(NX,J-1)-(PESPO*(Z(NX,J)-Z(NX,J-1))/144)))
      A(NX,J)=47.227E+06*AA(NX,J)



C	 WRITE(7,*)AZ(NX,J+1),AZ(NX,J)  
C	 WRITE(7,*)P(NX-1,J),LOOZ(NX,J)*ho(NX,J)*AZ(NX,J) 
C	 WRITE(7,*) T(NX,J-1),T(NX,J),T(NX,J+1)
C	 WRITE(7,*) AZ(NX,J-1),AZ(NX,J),AZ(NX,J+1)
      BB(NX,J)=(((CTSRO*AR(NX+1,J))/(RE-R(NX,J)))*(GRADT(NX,J)-T(NX,J)))
     & -(((CTSRO*AR(NX,J))/(R(NX,J)-R(NX-1,J)))*(T(NX,J)-GRADT(NX-1,J)))
     & +(((CTSRO*AZ(NX,J+1))/(Z(NX,J+1)-Z(NX,J)))*(T(NX,J+1)-T(NX,J)))
     & -(((CTSRO*AZ(NX,J))/(Z(NX,J)-Z(NX,J-1)))*(T(NX,J)-GRADT(NX,J-1)))
           B(NX,J)=4.4856E+15*BB(NX,J)



      CALL INTER(NPUNTOS,PT,BOT,P(NX,J),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(NX,J),YMUO,DMUO)
           MUO(NX,J)=YMUO
	     BO(NX,J)=YBO
           CC(NX,J)=(((PERMR*VR(NX,J))/(MUO(NX,J)*BO(NX,J)))
     &*(((P12R(NX,J)-P01R(NX,J))/(RE-R12(NX,J)))**2))
     &+(((PERMZ*VR(NX,J))/(MUO(NX,J)*BO(NX,J)))
     &*((((P12Z(NX,J)-P01Z(NX,J))/(Z12(NX,J+1)-Z12(NX,J)))**2)
     &-((PESPO/144)*((P12Z(NX,J)-P01Z(NX,J))/(Z12(NX,J+1)-Z12(NX,J))))))
           C(NX,J)=6800.7E+06*CC(NX,J)



       DD(NX,J)=LAMBDAOO(NX,J)*hot(NX,J)*(POTM(NX,J)-POT(NX,J))
       D(NX,J)=47.227E+06*DD(NX,J)
       EE(NX,J)=EPSILO(NX,J)*(TM(NX,J)-T(NX,J))
       E(NX,J)=44.856E+14*EE(NX,J)
       F(NX,J)=QoAST(NX,J)
       G(NX,J)=74.6496E+08*qoaste(NX,J)*ho(NX,J)
       H(NX,J)=A(NX,J)+B(NX,J)-C(NX,J)+D(NX,J)+E(NX,J)-F(NX,J)-G(NX,J)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

	CALL INTER(NPUNTOS,PT,DENT,PSNT(NX,J),DENSOSNT(NX,J),DDENSOSNT)
	 COMDEN(NX,J)=PORO*DENSOSNT(NX,J)
	 PERTER=(DELTAt*H(NX,J))/(74.6496E+08*VR(NX,J)*COMDEN(NX,J))
	SDOTER=(1.075E+12*(P(NX,J)-PSNT(NX,J)))/(74.6496E+08*COMDEN(NX,J))
	TERTER=(PORO*ho(NX,J)*DENSO(NX,J))/(COMDEN(NX,J))
	     hoSNT(NX,J)=PERTER-SDOTER+TERTER
             H2(NX,J)=hoSNT(NX,J)-ho(NX,J)
C           WRITE(7,*) A(NX,J)
C           WRITE(7,*) B(NX,J),C(NX,J),D(NX,J)
C           WRITE(7,*) E(NX,J),F(NX,J),G(NX,J)
C           WRITE(7,*) H(NX,J),H1(NX,J),H2(NX,J)

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(NX,J)=-(D(NX,J)+E(NX,J))

	CALL INTER(NPUNTOS,PT,DENT,PMSNT(NX,J),DENSOMSNT(NX,J),DDENSOMSNT)
	 COMDEN(NX,J)=POROM*DENSOMSNT(NX,J)
	 PERTER=(DELTAt*Hm(NX,J))/(74.6496E+08*VR(NX,J)*COMDEN(NX,J))
	 SDOTER=(1.075E+12*(PM(NX,J)-PMSNT(NX,J)))/(74.6496E+08
     &        *COMDEN(NX,J))
	 TERTER=(POROM*hom(NX,J)*DENSOM(NX,J))/(COMDEN(NX,J))
	     homSNT(NX,J)=PERTER-SDOTER+TERTER
             H2m(NX,J)=homSNT(NX,J)-hom(NX,J)

       END DO
C       STOP
         DO  J=2,NY-1
 
      CALL MNEWTON(NX,J,T(NX,J),P(NX,J),DENSO(NX,J),DENSOSNT(NX,J),
     &     hoSNT(NX,J),PSNT(NX,J),et,H2(NX,J),RO(NX,J),TE(NX,J))

      CALL MNEWTON(NX,J,TM(NX,J),PM(NX,J),DENSOM(NX,J),DENSOMSNT(NX,J)
     &     ,homSNT(NX,J),PMSNT(NX,J),et,H2m(NX,J),ROm(NX,J),TME(NX,J))

           WRITE(7,*)NX,J,TE(NX,J),TME(NX,J)
           WRITE(9,*)NX,J,RO(NX,J),ROm(NX,J)
         END DO
C       STOP
C   __________________________________________________________________________
CC  __________________________________________________________________________
CC  __________________________________________________________________________
CC  __________________________________________________________________________
C  --  PARA LA CELDA NX,NY
C  __________________________________________________________________________
C  -- DETERMINACIN DE LOS TRMINOS DE LA FUNCIN DE RESIDUOS PARA EL
C  -- SISTEMA DE FRACTURAS

       P12R(NX-1,NY)=P(NX-1,NY)+(((P(NX,NY)-P(NX-1,NY))/
     &              (R(NX,NY)-R(NX-1,NY)))*(R12(NX,NY)-R(NX-1,NY)))
       P01R(NX,NY)= P12R(NX-1,NY)
       P12R(NX,NY)= P(NX,NY)+(((P(NX,NY)-P12R(NX-1,NY))/
     &              (R(NX,NY)-R12(NX,NY)))*(RE-R(NX,NY)))
       P01Z(NX,NY)= P(NX,NY-1)+(((P(NX,NY)-P(NX,NY-1))/
     &              (Z(NX,NY)-Z(NX,NY-1)))*(Z12(NX,NY)-Z(NX,NY-1)))
       P12Z(NX,NY)= P(NX,NY)!+(((P(NX,NY+1)-P(NX,NY))/
C     &              (Z(NX,NY+1)-Z(NX,NY)))*(Z12(NX,NY+1)-Z(NX,NY)))
C	 WRITE(7,*) P01R(NX,J),P12R(NX,J)
C       WRITE(7,*) P01Z(NX,J),P12Z(NX,J)
       


      AA(NX,NY)=
     &   (((LOOR(NX,NY)*ho(NX,NY)*AR(NX+1,NY))/(RE-R(NX,NY)))
     &    *(P(NX,NY)-P(NX,NY)))
     &    -(((LOOR(NX,NY)*ho(NX,NY)*AR(NX,NY))/(R(NX,NY)-R(NX-1,NY)))
     &    *(P(NX,NY)-P(NX-1,NY)))
     &    +(((LOOZ(NX,NY)*ho(NX,NY)*AZ(NX,NY+1))/(ESPE-Z(NX,NY)))
     &    *(P(NX,NY)-P(NX,NY)-(PESPO*(ESPE-Z(NX,NY))/144)))
     &    -(((LOOZ(NX,NY)*ho(NX,NY)*AZ(NX,NY))/(Z(NX,NY)-Z(NX,NY-1)))
     &    *(P(NX,NY)-P(NX,NY-1)-(PESPO*(Z(NX,NY)-Z(NX,NY-1))/144)))
      A(NX,NY)=47.227E+06*AA(NX,NY)
C       WRITE(7,*) GRADT(NX,NY),T(NX,NY)



      BB(NX,NY)=
     &(((CTSRO*AR(NX+1,NY))/(RE-R(NX,NY)))
     &*(GRADT(NX,NY)-T(NX,NY)))
     &-(((CTSRO*AR(NX,NY))/(R(NX,NY)-R(NX-1,NY)))
     &*(T(NX,NY)-GRADT(NX-1,NY)))
     &+(((CTSRO*AZ(NX,NY+1))/(ESPE-Z(NX,NY)))
     &*(TCALIENTE-T(NX,NY)))
     &-(((CTSRO*AZ(NX,NY))/(Z(NX,NY)-Z(NX,NY-1)))
     &*(T(NX,NY)-GRADT(NX,NY-1)))
      B(NX,NY)=4.4856E+15*BB(NX,NY)



      CALL INTER(NPUNTOS,PT,BOT,P(NX,NY),YBO,DBO)
      CALL INTER(NPUNTOS,PT,MUOT,P(NX,NY),YMUO,DMUO)
           MUO(NX,NY)=YMUO
	     BO(NX,NY)=YBO
           CC(NX,NY)=(((PERMR*VR(NX,NY))/(MUO(NX,NY)*BO(NX,NY)))
     & *(((P12R(NX,NY)-P01R(NX,NY))/(RE-R12(NX,NY)))**2))
     & +(((PERMZ*VR(NX,NY))/(MUO(NX,NY)*BO(NX,NY)))
     & *((((P12Z(NX,NY)-P01Z(NX,NY))/(ESPE-Z12(NX,NY)))**2)
     & -((PESPO/144)*
     &     ((P12Z(NX,NY)-P01Z(NX,NY))/(ESPE-Z12(NX,NY))))))
           C(NX,NY)=6800.7E+06*CC(NY,NY)



       DD(NX,NY)=LAMBDAOO(NX,NY)*hot(NX,NY)*(POTM(NX,NY)-POT(NX,NY))
       D(NX,NY)=47.227E+06*DD(NX,NY)
       EE(NX,NY)=EPSILO(NX,NY)*(TM(NX,NY)-T(NX,NY))
       E(NX,NY)=44.856E+14*EE(NX,NY)
       F(NX,NY)=QoAST(NX,NY)
       G(NX,NY)=74.6496E+08*qoaste(NX,NY)*ho(NX,NY)
       H(NX,NY)=A(NX,NY)+B(NX,NY)-C(NX,NY)+D(NX,NY)+E(NX,NY)-F(NX,NY)
     & -G(NX,NY)

C           WRITE(7,*) A(NX,NY)
C           WRITE(7,*) B(NX,NY),C(NX,NY),D(NX,NY)
C           WRITE(7,*) E(NX,NY),F(NX,NY),G(NX,NY)
C           WRITE(7,*) H(NX,NY),H1(NX,NY),H2(NX,NY)
C        DO I=1,NX
C	     DO J=1,NY
C	       WRITE(7,*) I,J,T(I,J),TM(I,J)
C	     END DO
C        END DO
C       STOP

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA FRACTURA

	CALL INTER(NPUNTOS,PT,DENT,PSNT(NX,NY),DENSOSNT(NX,NY),DDENSOSNT)
	COMDEN(NX,NY)=PORO*DENSOSNT(NX,NY)
	PERTER=(DELTAt*H(NX,NY))/(74.6496E+08*VR(NX,NY)*COMDEN(NX,NY))
	SDOTER=(1.075E+12*(P(NX,NY)-PSNT(NX,NY)))/(74.6496E+08
     &       *COMDEN(NX,NY))
	TERTER=(PORO*ho(NX,NY)*DENSO(NX,NY))/(COMDEN(NX,NY))
	     hoSNT(NX,NY)=PERTER-SDOTER+TERTER
             H2(NX,NY)=hoSNT(NX,NY)-ho(NX,NY)

      CALL MNEWTON(NX,NY,T(NX,NY),P(NX,NY),DENSO(NX,NY),DENSOSNT(NX,NY),
     &     hoSNT(NX,NY),PSNT(NX,NY),et,H2(NX,NY),RO(NX,NY),TE(NX,NY))

C  -- CALCULO DE LA ENTALPIA ESPECFICA AL SIGUIENTE NIVEL DE TIEMPO
C  -- PARA DETERMINAR LA DISTRIBUCIN DE TEMPERATURA EN LA MATRIZ

           Hm(NX,NY)=-(D(NX,NY)+E(NX,NY))

	CALL INTER(NPUNTOS,PT,DENT,PMSNT(NX,NY),DENSOMSNT(NX,NY),
     &           DDENSOMSNT)
	COMDEN(NX,NY)=POROM*DENSOMSNT(NX,NY)
	PERTER=(DELTAt*Hm(NX,NY))/(74.6496E+08*VR(NX,NY)*COMDEN(NX,NY))
	SDOTER=(1.075E+12*(PM(NX,NY)-PMSNT(NX,NY)))/(74.6496E+08
     &       *COMDEN(NX,NY))
	TERTER=(POROM*hom(NX,NY)*DENSOM(NX,NY))/(COMDEN(NX,NY))
	     homSNT(NX,NY)=PERTER-SDOTER+TERTER
             H2m(NX,NY)=homSNT(NX,NY)-hom(NX,NY)

      CALL MNEWTON(NX,NY,TM(NX,NY),PM(NX,NY),DENSOM(NX,NY),
     &     DENSOMSNT(NX,NY),homSNT(NX,NY),PMSNT(NX,NY),et,H2m(NX,NY),
     &     ROm(NX,NY),TME(NX,NY))

           WRITE(7,*) NX,NY,TE(NX,NY),TME(NX,NY)
           WRITE(9,*) NX,NY,RO(NX,NY),ROm(NX,NY)

           WRITE(8,*)'                                             '
           WRITE(8,*)'LOCALIZACION DE NODOS Y FRONTERAS EN LA MALLA'
           WRITE(8,*)'          _____________________            '
           WRITE(8,*)'                                             '
           WRITE(8,*)'          _____________________            '
           WRITE(8,*)'          No. DE CELDAS EN  r,z            '
           WRITE(8,*) NX,NY
           WRITE(8,*)'                                             '
           WRITE(8,*)'          _____________________            '
           WRITE(8,*)'     POSICION DE LOS NODOS RADIALMENTE     '
           WRITE(8,*) (R(I,1),I=1,NX)
           WRITE(8,*)'                                             '
           WRITE(8,*)'          _____________________            '
           WRITE(8,*)'     POSICION DE LAS FRONTERAS RADIALMENTE     '
           WRITE(8,*) (R12(I,1),I=1,NX+1)
           WRITE(8,*)'                                             '
           WRITE(8,*)'          _____________________            '
           WRITE(8,*)'     POSICION DE LOS NODOS VERTICALMENTE     '
           WRITE(8,*) (Z(1,J),J=1,NY)
           WRITE(8,*)'                                             '
           WRITE(8,*)'          _____________________            '
           WRITE(8,*)'     POSICION DE LAS FRONTERAS VERTICALMENTE     '
           WRITE(8,*) (Z12(1,J),J=1,NY+1)



      END
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C::::::::::::::::::::::::: LECTURA DE DATOS :::::::::::::::::::::::::::
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C      SUBROUTINE DATOS()
C      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C      DIMENSION ESPN(100,20),ESPN12(100,20),BOT(20),MUOT(20),
C     &DENT(20),PT(20),DELTAZ(100,10),
C     &P(100,10),PM(100,10),PSNT(100,10),PMSNT(100,10),GVO(100,10)
C      COMMON NX,NY,RW,RE,UNIFORM,ESPN,ESPN12,DELTAZ,
C     &ESPE,TREF,P,PM,PSNT,PMSNT,GVO,PERMR,PERMZ,PERMATR,PERMATZ,PORO,
C     &POROM,CTO,RFCD,SIGMA,PESPO,DENCS,CTR,DENSW,DELTAt,IR,IBOUND,et
C      REAL MUOT
CC      REAL O-Z
C      READ(5,*) NX,NY,RW,RE,UNIFORM
CC  -- SELECCIN DE DATOS DE ENTRADA, ESPESOR VARIBLE EN LOS NODOS --
C      IF (UNIFORM.EQ.0) THEN
C         DO 3 J=1,NY
C            DO 3 I=1,NX
C                 READ(5,*) ESPN(I,J)
C   3     CONTINUE
C
CC  -- CALCULA LOS ESPESORES EN LAS FRONTERAS DE LAS CELDAS EN FUNCIN --
CC  -- DE LOS ESPESORES DE LOS NODOS --
C         DO 6 J=1,NY
C           DO 4 I=2,NX
C              ESPN12(I,J)=(ESPN(I,J)+ESPN(I-1,J))*0.5
C   4       CONTINUE
CC  -- EXTRAPOLACIN TRIVIAL PARA CALCULAR LOS ESPESORES DE LAS FRONTERAS --
CC  -- ES DECIR EN (1,J) Y (NX+1,J) --
C
C          IF (ESPN(2,J).GT.ESPN(1,J))THEN
C             ESPN12(1,J)= (ESPN12(2,J)+ESPN(1,J))*0.5
C          ELSE
C             ESPN12(1,J)=(ESPN(1,J)-ESPN12(2,J))+((ESPN12(2,J)+ESPN(1,J)
C     &            )*0.5)
C          END IF
C
C               IF (ESPN(2,J).GT.ESPN(1,J))THEN
C                   ESPN12(NX+1,J)= (ESPN12(NX,J)+ESPN(NX,J))*0.5
C               ELSE
C                   ESPN12(NX+1,J)=(ESPN(NX,J)-ESPN12(NX,J))+
C     &                  ((ESPN12(NX,J)+ESPN(NX,J))*0.5)
C               END IF
C
C   6    CONTINUE
C
CC  -- SE LEE EL ESPESOR TOTAL DEL YACIMIENTO Y SE CALCULA EL DE CADA --
CC  -- NODO (ESPESOR CONSTANTE) --
C      ELSE
C          READ(5,*) ESPE
C          ESPESOR=ESPE/NY
C      END IF
C
CC  -- INTRODUCCIN DE LOS DATOS PVT vs p
CC  -- LEER LA TEMPERATURA DEL EXPERIMENTO (TABLA)
C      READ(5,*) TREF
C      READ(5,*) PERMR,PERMZ,PERMATR,PERMATZ,PORO,POROM
C      READ(5,*) CTO,RFCD,SIGMA,PESPO,DENCS,DENSW,CTR
C      READ(5,*) DELTAt,IR,IBOUND
C      READ(5,*) et
C      READ(5,*) NPUNTOS
C         DO 8 I=1,NPUNTOS
C              READ(5,*) PT(I),MUOT(I),BOT(I),DENT(I)
C   8  CONTINUE
Cc 100  FORMAT (4F10.5)
C
CC  -- OTROS DATOS DE ENTRADA
C        DO 10 J=1,NY
C           DO 10 I=1,NX
C             READ(5,*) P(I,J),PM(I,J),PSNT(I,J),PMSNT(I,J),GVO(I,J)
C  10    CONTINUE
C      RETURN
C      END

C  -- PERMR.-PERMEABILIDAD DE LA FRACTURA EN DIRECCIN RADIAL
C  -- PERMZ.-PERMEABILIDAD DE LA FRACTURA EN DIRECCIN AXIAL
C  -- PERMATR.-PERMEABILIDAD DE LA MATRIZ EN DIRECCIN RADIAL
C  -- PERMATZ.-PERMEABILIDAD DE LA MATRIZ EN DIRECCIN AXIAL
C  -- PORO Y POROM.-POROSIDAD EN LA FRACTURA Y MATRIZ RESPECTIVAMENTE
C  -- CTO.-CONDUCTIVIDAD TERMICA DEL ACEITE
C  -- RFCD.-RITMO DE FLUJO DE CALOR PROPORCIONADO COMO DATO (POZO)
C  -- GVO.-GASTO VOLUMTRICO DE ACEITE
C  -- SIGMA.-FACTOR DE FORMA PARA LOS BLOQUES DE MATRIZ
C  -- PESPO.-PESO ESPECFICO DEL ACEITE
C  -- DENCS.-DENSIDAD A CONDICIONES SUPERFICALES DE PRODUCCIN
C  -- CP.-CALOR ESPECFICO DEL ACEITE
C  -- CTR.-CONDUCTIVIDAD TRMICA DE LA ROCA
C  -- PORI.-PRESIN ORIGINAL DEL YACIMIENTO
C  -- tFINAL.-TIEMPO TOTAL DE LA SIMULACIN
C  -- DELTAt.-INCREMENTO EN LA DISCRETIZACIN DEL TIEMPO
C  -- IR.-MODO DE GENERACIN DE LA MALLA (MANUAL, AUTOMTICA)
C  -- IBOUND.-MODO EN LA CONDICIN DE FRONTERA EXTERNA
C  -- LC.- LONGITUD CARACTERSTICA
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C::::POSICIN DE LOS NODOS DE LA MALLA EN DIRECCIN RADIAL:::::::::::::
C::LAS FRONTERAS DE LAS CELDAS TAMBIN SE ESTABLECEN (COATS,1970)::::::
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE RADIAL(N,NZ,RW,RE,R,R12,DIFR12,AZ,IR,IBOUND,PHI)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION R(100,100),R12(101,110),DIFR12(101,110),AZ(100,100)

      E     = 1./FLOAT(N)
      ALPHA = (RE/RW)**E

C  -- SE CALCULA TAMBIEN EL AREA TRANSVERSAL (POR CELDA) A LA DIRECCIN Z --
       IF(IBOUND .EQ. 1) GO TO 22
        CALL ALPCAL(RE,RW,ALPHA,N)
   22 RO     = RW*LOG(ALPHA)/(ALPHA-1.)

               IF( IR .EQ. 1 )GO TO 33

      DO 23 J=1,NZ
            R(1,J)   = ALPHA*RO
            R12(1,J) = RW
	      R12(N+1,J) = RE
C          IF( IR .EQ. 1 )GO TO 33 esta comparacin se saca del ciclo
         DO 3 I=2,(N+1)
            R(I,J)= ALPHA*R(I-1,J)
            R12(I,J)= (R(I,J)-R(I-1,J))/LOG(ALPHA)

    3    CONTINUE

         DO 4 I=1,N
            DIFR12(I,J)= PHI*(R12(I+1,J)**2. - R12(I,J)**2.)
    4       AZ(I,J)=DIFR12(I,J)
   23 CONTINUE

           DO 24 I=1,N
              AZ(I,NZ+1)=DIFR12(I,NZ)
   24      CONTINUE
           
      RETURN

   33 DO 233 J=1,NZ
            R(1,J)   = ALPHA*RO
            R12(1,J) = RW
      
      DO 44 I=2,N
            R(I,J)= ALPHA*LOG(ALPHA)*R12(I+1,J)/(ALPHA-1.)
   44       DIFR12(I,J)= PHI*(R12(I+1,J)**2. - R12(I,J)**2.)

      DO 45 I=1,N
          AZ(I,J)=DIFR12(I,J)
   45 CONTINUE
  233 CONTINUE

           DO 25 I=1,N
              AZ(I,NZ+1)=DIFR12(I,NZ)
   25      CONTINUE

      RETURN
      END
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
       SUBROUTINE ALPCAL(RE,RW,ALP,NR)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DO 1 I=1,100
            F= (ALP**NR)*DLOG(ALP)/(ALP - 1.0D0) - RE/RW
            ERR= ABS(F)
         IF(ERR .LT. 1.E-06) THEN
            RETURN
         ELSE
            X1= ALP**(NR-1)
            X2= ALP - 1.0D0
            X3= DLOG(ALP)
            FF= X1*(NR*X3 + 1.0D0)/X2 - ALP*X1*X3/(X2**2)
            ALP= ALP - F/FF
         END IF
    1  CONTINUE
C
C
       WRITE(7,*)
   10  FORMAT(1X,'ERROR IN RADIAL MESH ROUTINE: NUMBER OF ITERATIONS
     & EXCEEDED')
       STOP
       END
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C::::::::::::::POSICIN DE LOS NODOS EN DIRECCIN Z:::::::::::::::::::
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      SUBROUTINE AXIAL(N,NZ,ESPN,ESPESOR,Z,Z12,UNIFORM,DELTAZ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION EM(100,100),Z(100,100),Z12(101,110),DELTAZ(101,110),
     &ESPN(100,10)

        IF (UNIFORM.EQ.0) THEN
           DO 1 J=1,NZ
              DO 1 I=1,N
                    EM(I,J)=ESPN(I,J)*0.5
    1      CONTINUE
           DO 3 I=1,N
                Z(I,1)=EM(I,1)
                Z12(I,1)=0.0
                DELTAZ(I,1)=Z(I,1)
    3      CONTINUE
           DO 2 J=2,NZ
              DO 2 I=1,N
                   Z(I,J)=Z(I,J-1)+(0.5*ESPN(I,J-1))+EM(I,J)
                   DELTAZ(I,J)=Z(I,J)-Z(I,J-1)
    2      CONTINUE
           DO 9 J=2,NZ+1
              DO 9 I=1,N
                   Z12(I,J)=Z(I,J-1)+EM(I,J-1)
    9      CONTINUE
        ELSE
           DO 7 I=1,N
                Z(I,1)=ESPESOR*0.5
                Z12(I,1)=0.0
                DELTAZ(I,1)=Z(I,1)
    7      CONTINUE
           DO 8 J=2,NZ
                K=K+1
              DO 8 I=1,N
                   Z(I,J)=ESPESOR*(K+0.5)
                   DELTAZ(I,J)=Z(I,J)-Z(I,J-1)
    8      CONTINUE
           DO 10 J=2,NZ+1
                 L=L+1
              DO 10 I=1,N
                    Z12(I,J)=ESPESOR*L
   10      CONTINUE
        END IF
        RETURN
      END

C  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INTER(N,PT,BOT,X,BO,DBO)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION PT(20),BOT(20)
C
      DO 10 KK=2,N
      K=N-KK+1
      IF(X.GE.PT(K)) GOTO 20
   10 CONTINUE
   20 A3=PT(K+1)-PT(K)
      A1=(X-PT(K))/A3
      A2=(X-PT(K+1))/A3
      BO=A1*BOT(K+1)-A2*BOT(K)
      DBO=(BOT(K+1)-BOT(K))/A3
      RETURN
      END


C  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C      SUBROUTINE MNEWTON(I,J,T,TITER,K,P,DENSOSNT,hoSNT)
C      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C      DIMENSION TITER(0:100)
C           f=((0.006221*T)+(7.2148E-06*T**2)+(P*
C     &       0.1852))*(1/DENSOSNT)-hoSNT
C           df=(1/DENSOSNT)*(0.006221+(14.4296E-06*T))

C           K=0
C           TITER(0)=T
CC	WRITE (7,*) hoSNT,f,df

C       DO WHILE (ABS(f).GT.1E-04)
C	     K=K+1
C           f=((0.006221*TITER(K-1))+(7.2148E-06*TITER(K-1)**2)+(P*
C     &       0.1852))*(1/DENSOSNT)-hoSNT
C           df=(1/DENSOSNT)*(0.006221+(14.4296E-06*TITER(K-1)))
C           TITER(K)=TITER(K-1)-(f/df)
CC	     T(I,J)=TITER(K)

C           WRITE(7,*)K,f,TITER(K-1)
C       END DO
CC           WRITE(7,*)I,J,TITER(K)
C       RETURN
C       END
      
C  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE MNEWTON(I,J,T,P,DENSO,DENSOSNT,hoSNT,PSNT,et,
     &H2,RO,TE)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
        	 
	 DDCRT=-DENSOSNT*et

C       WRITE(9,*) I,J,PSNT
C	WRITE (*,*)I,J,DENSOSNT
C        Tini = T(I,J)
        TE = T-0.5
	
       DO
        RO = DENSOSNT*(1-et*(TE-TREF))
	  DENCRT = H2/(TE-T)
	  UNO=25036.86*TE*(RO**(-0.5))*
     &           (3.064954+0.0035547*TE)
        DOS=144*(PSNT/RO)-hoSNT
        TRES=25036.86*TE*(RO**(-0.5))*0.0035547
        CUATRO=25036.86*(3.064954+0.0035547*TE)
     &              *(RO**(-0.5))
	  CINCO=25036.86*0.5*(RO**(-1.5))*DDCRT*TE
     &             *(3.064954+0.0035547*TE)
	  SEIS=144*(P/(RO**2))*DDCRT
	  SIETE=DENCRT
        f = UNO + DOS
        df=TRES+CUATRO-CINCO-SEIS-SIETE
	     RAIZ=TE-(f/df)
	       IF (ABS((TE-RAIZ)/RAIZ) .LT. 1.0E-04) RETURN
	     TE = RAIZ
C        WRITE (*,*) I,J,'TE =',TE(I,J)
       END DO
       END